from typing import List

from pydantic import BaseModel


class FindRequestBase(BaseModel):
    limit: int = None
    page: int = None


class FindRequestQianzhan(BaseModel):
    pageNum: int = 1
    pageSize: int = 10

class FindRequestQcc(BaseModel):
    pageNum: int = 1
    pageSize: int = 10

class ResponseBase(BaseModel):
    code: int = 1000
    msg: str = "请求成功"
    data: dict = {}


