
import re
import string
import asyncio
import time
import uuid
from urllib.parse import urlencode

from bs4 import BeautifulSoup
import hashlib
import random

from utils.ptools import fs_send_msg, get_cookies, get_domain, clean_title, put_logs
import oss2
from datetime import datetime
from loguru import logger
import aiohttp

proxy_list = [
    "117.33.148.180:16817"
]
# 用户名密码认证(私密代理/独享代理)
username = "ohimbkvo"
password = "tz4iya07"

proxy_auth = aiohttp.BasicAuth(username, password)
proxy = "http://" + random.choice(proxy_list)


async def fetch(session, url):
    async with session.get(url, proxy=proxy, proxy_auth=proxy_auth) as resp:
        content = await resp.read()


proxyHost = "http-dyn.abuyun.com"
proxyPort = "9020"
# 代理隧道验证信息
proxyUser = "HUGE9Q7E68J43M2D"
proxyPass = "9D73B37F9FC7A688"

proxyMeta = "http://%(user)s:%(pass)s@%(host)s:%(port)s" % {
    "host": proxyHost,
    "port": proxyPort,
    "user": proxyUser,
    "pass": proxyPass,
}

headers = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
    'Accept-Language': 'zh-CN,zh;q=0.9',
    'Cache-Control': 'max-age=0',
    'Connection': 'close',
    'Sec-Fetch-Dest': 'document',
    'Sec-Fetch-Mode': 'navigate',
    'Sec-Fetch-Site': 'none',
    'Sec-Fetch-User': '?1',
    'Upgrade-Insecure-Requests': '1',
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36',
    'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
    'sec-ch-ua-mobile': '?0',
    'sec-ch-ua-platform': '"macOS"',
}


def generate_md5(string):  # 字符串转md5
    m = hashlib.md5()
    m.update(string.encode('utf-8'))
    return m.hexdigest()


# async def download_image(url):
#     image_timeout = 2
#     image_data = None
#     if not url:
#         return url, image_data
#     if url.startswith("http"):
#         retries = 0
#         try:
#             conn = aiohttp.TCPConnector(ssl=False)
#             async_timeout = aiohttp.ClientTimeout(total=image_timeout)
#             async with aiohttp.ClientSession(connector=conn) as session:
#                 async with session.get(url, timeout=async_timeout) as response:
#                     image_data = await response.read()
#                     return url, image_data
#         except asyncio.TimeoutError as e:
#             retries += 1
#             logger.error(f'error==图片 请求超时错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
#         except aiohttp.ClientError as e:
#             retries += 1
#             logger.error(f'error==图片 客户端请求错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
#         except Exception as e:
#             retries += 1
#             logger.error(f'error==图片 请求未知错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
#         finally:
#             return url, image_data
#     else:
#         return url, image_data


async def download_image(url):
    image_timeout = 2
    image_data = None
    if not url:
        return url, image_data
    if url.startswith("http"):
        retries = 0
        try:
            conn = aiohttp.TCPConnector(ssl=False)
            async_timeout = aiohttp.ClientTimeout(total=image_timeout)
            async with aiohttp.ClientSession(connector=conn) as session:
                async with session.get(url, timeout=async_timeout) as response:
                    image_data = await response.read()
                    return url, image_data
        except asyncio.TimeoutError as e:
            retries += 1
            logger.error(f'error==图片 请求超时错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        except aiohttp.ClientError as e:
            retries += 1
            logger.error(f'error==图片 客户端请求错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        except Exception as e:
            retries += 1
            logger.error(f'error==图片 请求未知错误 timeout={image_timeout}：Retry {retries} for {url} -- {e}')
        finally:
            return url, image_data
    else:
        return url, image_data


async def upload_image(url_list):
    img_item = {}
    tasks = [download_image(url) for url in url_list]
    image_datas = await asyncio.gather(*tasks)
    for url, image_data in image_datas:
        if url:
            if image_data:
                file_name = generate_md5(url) + ".png"
                auth = oss2.Auth('LTAI5tCk5dyxAFbu4osESe1T', 'VdLysdFG1pjHu9U7bTuLCZx0lQFLbJ')
                bucket = oss2.Bucket(auth, 'oss-cn-hangzhou-internal.aliyuncs.com', 'lianqiai-public')
                result = bucket.put_object('upload/bing_logo/' + file_name, image_data)
                if result.status == 200:
                    oss_url = f'https://lianqiai-public.oss-cn-hangzhou.aliyuncs.com/upload/bing_logo/{file_name}'
                    # print(f"上传成功 url长度{len(url)}-- {url} -- {oss_url}")
                    img_item[generate_md5(url)] = {
                        'url': url,
                        'oss_url': oss_url
                    }
                else:
                    logger.error(f"文件上传失败 {result.status} {result.resp.body}")
            else:
                img_item[generate_md5(url)] = {
                    'url': url,
                    'oss_url': None
                }
    return img_item


def time_to_int(date_str2):
    date_str1 = '1970-01-01'
    date1 = datetime.strptime(date_str1, '%Y-%m-%d')
    date2 = datetime.strptime(date_str2, '%Y-%m-%d')
    delta = date2 - date1
    days_difference = delta.days
    return days_difference


def clean_html_tags(html_content):
    clean_text = re.sub('<[^<]+?>|\\n', '', html_content)
    clean_text = ' '.join(clean_text.split())
    return clean_text


async def fetch_url(url, timeout, max_retries=1, cookies_bool=False, check_value=None, to_headers=None, proxies_bool=False):

    if proxies_bool:
        global proxy, proxy_auth
    else:
        proxy, proxy_auth = None, None
    print('proxy', proxy, proxy_auth)
    retries = 0
    while retries < max_retries:
        try:

            conn = aiohttp.TCPConnector(ssl=False)
            async_timeout = aiohttp.ClientTimeout(total=timeout)
            proxy, proxy_auth = None, None
            async with aiohttp.ClientSession(headers=to_headers, connector=conn) as session:
                if cookies_bool:
                    cookies = get_cookies()
                    async with session.get(url, timeout=async_timeout, cookies=cookies, proxy=None, proxy_auth=None) as response:
                        rex_text = await response.text()
                        if check_value and check_value not in rex_text:
                            raise Exception(f"check_value 不存在== {check_value}")
                        return rex_text
                else:
                    async with session.get(url, timeout=async_timeout, proxy=None, proxy_auth=None) as response:
                        rex_text = await response.text()
                        if check_value and check_value not in rex_text:
                            raise Exception(f"check_value 不存在== {check_value}")
                        return rex_text
        except asyncio.TimeoutError as e:
            retries += 1
            logger.error(f'error== 请求超时错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except aiohttp.ClientError as e:
            retries += 1
            logger.error(f'error== 客户端请求错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
        except Exception as e:
            retries += 1
            logger.error(f'error== 请求未知错误 timeout={timeout}：Retry {retries} for {url} -- {e}')
    logger.error(f"error==  请求重试后最终失败{url}")
    return None


def get_random_params():
    bduss = ''.join(random.choices(string.ascii_letters + string.digits, k=176))
    baiduid = uuid.uuid4().hex.upper()[:32]
    isid = uuid.uuid4().hex
    rsv_pq = hex(random.getrandbits(64))
    rsv_t = hashlib.md5(str(time.time()).encode('utf-8')).hexdigest()
    rsv_sid = '_'.join([str(random.randint(60000, 60300)) for _ in range(6)])
    clist = uuid.uuid4().hex
    _cr1 = hashlib.md5(str(random.getrandbits(128)).encode('utf-8')).hexdigest()
    timestamp = int(time.time() * 1000)
    r = ''.join(random.choices(string.digits, k=4))
    params_res = {
        'bduss': bduss,
        'baiduid': baiduid,
        'isid': isid,
        'rsv_pq': rsv_pq,
        'rsv_t': rsv_t,
        'rsv_sid': rsv_sid,
        'clist': clist,
        '_cr1': _cr1,
        'timestamp': timestamp,
        'r': r
    }
    print("params_res==", params_res)
    return params_res


def extract_baidupc_data(html_content):
    soup = BeautifulSoup(html_content, 'html.parser')
    search_results = soup.select('div[tpl="se_com_default"]')
    result_data = []
    for result in search_results:
        title_element = result.select_one('h3.c-title')
        url = result.get('mu')
        description = ""
        date_time = ""
        source = ""
        summary_element = result.select_one('span[class^="content-right_"]')
        if summary_element:
            description = clean_html_tags(summary_element.get_text().strip())

        date_time_element = result.select_one('span.c-color-gray2')
        if date_time_element:
            date_time = date_time_element.get_text().strip()

        source_element = result.select_one('span.c-color-gray')
        if source_element:
            source = source_element.get_text().strip()
        div_tags = result.find_all('div', class_='compatible_rxApe')
        # 遍历这些div标签，找到其中的img标签，并打印其src属性
        icon_url = None
        for div in div_tags[:1]:
            img_tag = div.find('img')
            if img_tag:
                src = img_tag['src']
                if len(src) == 142:
                    icon_url = src

        if title_element and url:
            title_text = clean_html_tags(title_element.get_text().strip())
            retrieval_dict = {
                "publish": source,
                "title": title_text,
                "link": url,
                "snippet": description,
                "ext_attrs": {
                    "date": date_time
                },
                "icon": {
                    "url": icon_url,
                    "oss_url": None,
                }
            }
            print('retrieval_dict==', retrieval_dict)
            # if any(domin in url for domin in false_url):
            #     logger.info(f"规则筛选触发 {url}")
            # else:
            result_data.append(retrieval_dict)
    return result_data


async def main_query(query, max_page, freshness, require_icon=False):
    old_max_page = max_page  # 如果需要数量够，可以max_page+n
    max_page += 1
    if freshness and ".." in freshness:
        freshness = freshness.replace('-', '')
    logger.info(f'info==1 开始查询query={query} max_page={max_page} freshness={freshness} require_icon={require_icon}')
    random_params = get_random_params()
    headers = {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
        'Accept-Language': 'zh-CN,zh;q=0.9',
        'Cache-Control': 'no-cache',
        'Connection': 'close',
        'Host': 'www.baidu.com',
        'Referer': 'http://www.baidu.com/',
        'cookie': f'BAIDUID={random_params["baiduid"]}:FG=1; BAIDUID_BFESS={random_params["baiduid"]}:FG=1; ' \
                  f'BDUSS={random_params["bduss"]}; H_PS_645EC={random_params["rsv_t"]}; H_PS_PSSID={random_params["rsv_sid"]}',
        'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/124.0.0.0 Safari/537.36'
    }
    list_url = []
    params = {
        'wd': query,
        'ie': 'utf-8',
        'f': '8',
        'rsv_bp': '1',
        'rsv_idx': '1',
        'tn': 'baidu',
        'fenlei': '256',
        'rqlang': 'cn',
        'rsv_enter': '1',
        'rsv_dl': 'tb',
        'rsv_btype': 'i',
        'inputT': '2751',
        'mod': '1',
        'isbd': '1',
        'isid': random_params['isid'],
        'rsv_pq': random_params['rsv_pq'],
        'rsv_t': random_params['rsv_t'],
        'tfflag': '1',
        'bs': query,
        'rsv_sid': random_params['rsv_sid'],
        '_ss': '1',
        'clist': random_params['clist'],
        'hsug': '',
        'f4s': '1',
        'csor': '20',
        '_cr1': random_params['_cr1'],
    }
    if 'site:' in query:
        site = query.split('site:')[1].strip()
        params['si'] = site
        # params['ct'] = '2097152'
    # 搜索指定日期范围
    if freshness:
        start_date, end_date = freshness.split('..')
        start_timestamp = int(datetime.strptime(start_date, '%Y%m%d').timestamp())
        end_timestamp = int(datetime.strptime(end_date, '%Y%m%d').timestamp())
        params['gpc'] = f'stf={start_timestamp},{end_timestamp}|stftype=2'

    for pn in range(1, old_max_page + 1):
        url = 'http://www.baidu.com/s'
        params['pn'] = str((int(pn) - 1) * 10)
        encoded_params = urlencode(params)
        full_url = f"{url}?{encoded_params}"
        list_url.append(full_url)
    logger.info(f'info==2 初步获取列表url_list {list_url}')
    tasks = [fetch_url(url, 9, max_retries=10, cookies_bool=False, check_value=None, to_headers=headers) for url in
             list_url]
    results = await asyncio.gather(*tasks)
    item_list = []
    for index_, result in enumerate(results):
        print('results', results)
        if isinstance(results, str):
            if '百度安全验证' in results or results.strip() == '':
                print('百度安全验证')
                fs_send_msg("error", "baidu_list",
                            f"搜索 query={query}, max_pages={old_max_page}, freshness={freshness}, require_icon={require_icon} 出现百度安全验证")
            elif '未找到相关结果' in results:
                print('未找到相关结果')
                fs_send_msg("error", "baidu_list",
                            f"搜索 query={query}, max_pages={old_max_page}, freshness={freshness}, require_icon={require_icon} 出现未找到相关结果")

            item_list = item_list + extract_baidupc_data(result)
    print('item_list', item_list)
    return item_list, 0


def get_ctitle():
    text_ = """<li class="b_algo" data-id="" iid=""><div class="b_tpcn"><a class="tilk" aria-label="职友集" href="https://www.jobui.com/company/12550115/" h="ID=SERP,5241.1"><div class="tpic"><div class="wr_fav" data-priority="2"><div class="cico siteicon" style="width:32px;height:32px;"><div class="rms_iac" style="height:32px;line-height:32px;width:32px;" data-height="32" data-width="32" data-alt="全球 Web 图标" data-class="rms_img" data-src="https://ts4.cn.mm.bing.net/th?id=ODLS.93603b31-1627-4280-b864-5a2f10d42b49&amp;w=32&amp;h=32&amp;qlt=92&amp;pcl=fffffa&amp;o=6&amp;pid=1.2"></div></div></div></div><div class="tptxt"><div class="tptt">职友集</div><div class="tpmeta"><div class="b_attribution" u="2|5102|4516321744148965|3Jg5ch4DEEoFyXQaRFfVgImjEgkbvV4y" tabindex="0"><span class="lcksb"></span><cite>https://www.jobui.com/company/12550115</cite><span class="c_tlbxTrg"><span class="c_tlbxH" h="BASE:CACHEDPAGEDEFAULT" k="SERP,5242.1"></span></span></div></div></div></a></div><div class="b_imgcap_altitle b_imgcap_nosc"><div class="b_imagePair square_mp reverse"><div class="inner"><div><a data-priority="2" target="_self" aria-label="https://www.jobui.com/company/12550115/" href="https://www.jobui.com/company/12550115/" h="ID=SERP,5230.1"><div class="rms_iac" style="height:92px;line-height:92px;width:92px;" data-height="92" data-width="92" data-class="b_circleImage b_onfaimg  rms_img" data-fdopt="False" data-alt="https://www.jobui.com/company/12550115/" data-aria-hidden="true" data-title="https://www.jobui.com/company/12550115/" data-src="https://ts4.cn.mm.bing.net/th?id=OIP-C.eKcpc2YGpUNm9URCUcg7AwAAAA&amp;w=92&amp;h=92&amp;c=1&amp;vt=9&amp;bgcl=cb9304&amp;r=0&amp;o=6&amp;pid=5.1"></div></a></div></div><h2><a target="_blank" href="https://www.jobui.com/company/12550115/" h="ID=SERP,5241.2">「山东天星<strong>北斗怎么样</strong>」山东天星<strong>北斗信息科技</strong>有 …</a></h2><p class="b_lineclamp3">山东天星<strong>北斗信息科技</strong>有限<strong>公司</strong>是齐鲁交通<strong>信息</strong>集团控股<strong>的</strong>***高新技术<strong>企业</strong>。 <strong>公司</strong>融合卫星定位技术、组合惯性导航技术、多传感器融合技术、物联网技术等前沿技术，专注于为各行业物联网体系提供准确、可信、可用<strong>的</strong>时空参数与<strong>北</strong> …</p></div></div><div class="b_caption b_rich" role="contentinfo"></div></li>
"""
    soup = BeautifulSoup(text_, "lxml")
    snippet = soup.css('div.b_caption *::text')
    print(snippet)





if __name__ == '__main__':

    # for i in range(1, 2):
    #     asyncio.run(
    #         main_query("北京星智管理咨询合伙企业（有限合伙） 陈歆 履历 新闻 发言", 1, '20240701..20240702', False))

    import requests

    proxy_ip = "58.241.101.70:10381"
    username = "GplQoKSu"
    password = "CvvpTesQ"
    dm_proxies = {
        "http": "http://%(user)s:%(pwd)s@%(proxy)s/" % {"user": username, "pwd": password, "proxy": proxy_ip},
        "https": "http://%(user)s:%(pwd)s@%(proxy)s/" % {"user": username, "pwd": password, "proxy": proxy_ip}
    }
    headers = {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7',
        'Accept-Language': 'zh-CN,zh;q=0.9',
        'Cache-Control': 'max-age=0',
        'Connection': 'close',
        'Sec-Fetch-Dest': 'document',
        'Sec-Fetch-Mode': 'navigate',
        'Sec-Fetch-Site': 'none',
        'Sec-Fetch-User': '?1',
        'Upgrade-Insecure-Requests': '1',
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/126.0.0.0 Safari/537.36',
        'sec-ch-ua': '"Not/A)Brand";v="8", "Chromium";v="126", "Google Chrome";v="126"',
        'sec-ch-ua-mobile': '?0',
        'sec-ch-ua-platform': '"macOS"',
    }
    url = "https://b2b.huangye88.com/qiye1191723/"
    response = requests.get(url, headers=headers,  proxies=dm_proxies)
    response.encoding = "utf-8"
    print(response.text)
